Altibase.jdbc.driver.datatype

## Class NumberColumn

- java.lang.Object
- - Altibase.jdbc.driver.datatype.NumberColumn

All Implemented Interfaces:
  Column

    public class NumberColumn
    extends java.lang.Object

### Field Summary

Fields
`protected java.math.BigDecimal` `mBigDecimalValue`
`protected boolean` `mIsNull`
`protected java.util.Set<java.lang.Integer>` `mMappedJdbcTypeSet`
`protected int` `mMaxBinaryLength`
`protected short` `mSize`
`protected java.util.List<java.lang.Object>` `mValues`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected void` `addMappedJdbcTypeSet(int aType)`
`protected void` `checkPrecisionOverflow(int aPrecision)`
`protected void` `checkScaleOverflow(int aScale)`
`void` `clearCurrentColumnValue()`
`void` `clearCurrentValue()`
`void` `clearValues()` 컬럼데이터가 저장되어 있는 ArrayList를 초기화 한다.
`DynamicArray` `createTypedDynamicArray()`
`java.io.InputStream` `getAsciiStream()`
`protected java.io.InputStream` `getAsciiStreamSub()`
`java.math.BigDecimal` `getBigDecimal()`
`protected java.math.BigDecimal` `getBigDecimalSub()`
`java.io.InputStream` `getBinaryStream()`
`protected java.io.InputStream` `getBinaryStreamSub()`
`java.sql.Blob` `getBlob()`
`protected java.sql.Blob` `getBlobSub()`
`boolean` `getBoolean()`
`protected boolean` `getBooleanSub()`
`byte` `getByte()`
`byte[]` `getBytes()`
`protected byte[]` `getBytesSub()`
`protected byte` `getByteSub()`
`java.io.Reader` `getCharacterStream()`
`protected java.io.Reader` `getCharacterStreamSub()`
`java.sql.Clob` `getClob()`
`protected java.sql.Clob` `getClobSub()`
`int` `getColumnIndex()` 컬럼의 인덱스를 가져온다.
`ColumnInfo` `getColumnInfo()`
`java.sql.Date` `getDate()`
`java.sql.Date` `getDate(java.util.Calendar aCalendar)`
`protected java.sql.Date` `getDateSub()`
`protected java.sql.Date` `getDateSub(java.util.Calendar aCalendar)`
`int` `getDBColumnType()`
`java.lang.String` `getDBColumnTypeName()`
`void` `getDefaultColumnInfo(ColumnInfo aColumnInfo)`
`double` `getDouble()`
`protected double` `getDoubleSub()`
`float` `getFloat()`
`protected float` `getFloatSub()`
`int` `getInt()`
`protected int` `getIntSub()`
`long` `getLong()`
`protected long` `getLongSub()`
`java.util.Set<java.lang.Integer>` `getMappedJDBCTypes()`
`int` `getMaxBinaryLength()`
`int` `getMaxDisplaySize()`
`java.lang.Object` `getObject()`
`java.lang.String` `getObjectClassName()`
`protected java.lang.Object` `getObjectSub()`
`int` `getOctetLength()` SQL/CLI 의 SQL_DESC_OCTET_LENGTH 에 대응되는 column 의 최대 길이를 반환한다.
`short` `getShort()`
`protected short` `getShortSub()`
`java.lang.String` `getString()`
`protected java.lang.String` `getStringSub()`
`java.sql.Time` `getTime()`
`java.sql.Time` `getTime(java.util.Calendar aCalendar)`
`java.sql.Timestamp` `getTimestamp()`
`java.sql.Timestamp` `getTimestamp(java.util.Calendar aCalendar)`
`protected java.sql.Timestamp` `getTimestampSub()`
`protected java.sql.Timestamp` `getTimestampSub(java.util.Calendar aCalendar)`
`protected java.sql.Time` `getTimeSub()`
`protected java.sql.Time` `getTimeSub(java.util.Calendar aCalendar)`
`boolean` `isArrayCompatible(DynamicArray aArray)`
`boolean` `isCleared()`
`boolean` `isMappedJDBCType(int aSqlType)`
`boolean` `isNull()`
`protected boolean` `isNullValueSet()`
`boolean` `isNumberType()`
`void` `loadFrom(DynamicArray aArray)`
`void` `loadFrom(int aLoadIndex)` ArrayList로 부터 컬럼데이터를 읽어들인다.
`protected void` `loadFromSub(DynamicArray aArray)`
`protected void` `loadFromSub(int aLoadIndex)`
`int` `prepareToWrite(CmBufferWriter aBufferWriter)` `Column.writeTo(CmBufferWriter)`로 에 쓸 준비를 하고, 쓸 데이타의 길이를 반환한다.
`protected void` `readAndStoreValue(CmChannel aChannel)`
`void` `readFrom(CmChannel aChannel, CmFetchResult aFetchResult)` 채널로부터 컬럼데이터를 읽어와 해당하는 인덱스의 DynamicArray에 바로 저장한다.
`protected void` `readFromSub(CmChannel aChannel)`
`protected void` `readFromSub(CmChannel aChannel, DynamicArray aArray)` 채널로부터 컬럼데이터를 읽어 바로 DynamicArray에 저장한다.
`void` `readParamsFrom(CmChannel aChannel)`
`void` `readParamsFromSub(CmChannel aChannel)`
`void` `setCleared(boolean aIsCleared)`
`void` `setColumnIndex(int aColumnIndex)` 컬럼 인덱스를 셋팅한다.
`void` `setColumnInfo(ColumnInfo aInfo)`
`void` `setMaxBinaryLength(int aMaxLength)`
`protected void` `setNull()`
`protected void` `setNullOrNotNull()`
`protected void` `setNullValue()`
`void` `setValue(java.lang.Object aValue)`
`protected void` `setValueSub(java.lang.Object aValue)`
`void` `storeTo()` 컬럼 데이터를 ArrayList에 저장한다.
`void` `storeTo(DynamicArray aArray)`
`void` `storeTo(ListBufferHandle aBufferWriter)` List Protocol 을 위한 ByteBuffer 에 프로토콜에서 정의한 바이너리 형태로 데이타를 쓴다.
`int` `writeTo(CmBufferWriter aBufferWriter)` ByteBuffer에 프로토콜에서 정의한 바이너리 형태로 데이타를 쓴다.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### mSize

    protected short mSize

#### mBigDecimalValue

    protected java.math.BigDecimal mBigDecimalValue

#### mIsNull

    protected boolean mIsNull

#### mMaxBinaryLength

    protected int mMaxBinaryLength

#### mValues

    protected java.util.List<java.lang.Object> mValues

#### mMappedJdbcTypeSet

    protected java.util.Set<java.lang.Integer> mMappedJdbcTypeSet

### Method Detail

#### getDBColumnType

    public int getDBColumnType()

#### getDBColumnTypeName

    public java.lang.String getDBColumnTypeName()

#### getDefaultColumnInfo

    public void getDefaultColumnInfo(ColumnInfo aColumnInfo)

#### getObjectClassName

    public java.lang.String getObjectClassName()

#### getMaxDisplaySize

    public int getMaxDisplaySize()

#### getOctetLength

    public int getOctetLength()

Description copied from interface: `Column`
SQL/CLI 의 SQL_DESC_OCTET_LENGTH 에 대응되는 column 의 최대 길이를 반환한다.

#### createTypedDynamicArray

    public DynamicArray createTypedDynamicArray()

#### isArrayCompatible

    public boolean isArrayCompatible(DynamicArray aArray)

#### storeTo

    public void storeTo(DynamicArray aArray)

#### storeTo

    public void storeTo()

Description copied from interface: `Column`
컬럼 데이터를 ArrayList에 저장한다.

#### storeTo

    public void storeTo(ListBufferHandle aBufferWriter)
                 throws java.sql.SQLException

Description copied from interface: `Column`
List Protocol 을 위한 ByteBuffer 에 프로토콜에서 정의한 바이너리 형태로 데이타를 쓴다.

Specified by:
  `storeTo` in interface `Column`
Parameters:
  `aBufferWriter` - 데이타를 쓸 ByteBuffer Writer
Throws:
  `java.sql.SQLException` - 데이타 전송에 실패했을 경우

#### prepareToWrite

    public int prepareToWrite(CmBufferWriter aBufferWriter)
                       throws java.sql.SQLException

Description copied from interface: `Column`
`Column.writeTo(CmBufferWriter)`로 에 쓸 준비를 하고, 쓸 데이타의 길이를 반환한다.

Parameters:
  `aBufferWriter` - 데이타를 쓸 ByteBuffer Writer
Returns:
  쓸 데이타의 바이트 길이
Throws:
  `java.sql.SQLException` - 쓸 데이타를 준비하는데 실패했을 경우

#### checkPrecisionOverflow

    protected void checkPrecisionOverflow(int aPrecision)

#### checkScaleOverflow

    protected void checkScaleOverflow(int aScale)

#### writeTo

    public int writeTo(CmBufferWriter aBufferWriter)
                throws java.sql.SQLException

Description copied from interface: `Column`
ByteBuffer에 프로토콜에서 정의한 바이너리 형태로 데이타를 쓴다.

Parameters:
  `aBufferWriter` - 데이타를 쓸 ByteBuffer Writer
Returns:
  ByteBuffer에 쓴 데이타 사이즈(byte 단위)
Throws:
  `java.sql.SQLException` - 데이타 전송에 실패했을 경우

#### setNullValue

    protected void setNullValue()

#### isNullValueSet

    protected boolean isNullValueSet()

#### readFromSub

    protected void readFromSub(CmChannel aChannel)
                        throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### readFromSub

    protected void readFromSub(CmChannel aChannel,
                               DynamicArray aArray)
                        throws java.sql.SQLException

채널로부터 컬럼데이터를 읽어 바로 DynamicArray에 저장한다.

Parameters:
  `aChannel` - 소켓통신을 위한 채널객체
  `aArray` - 컬럼데이터를 저장할 DynamicArray객체
Throws:
  `java.sql.SQLException` - 정상적으로 컬럼데이터를 로드하지 못한 경우

#### readAndStoreValue

    protected void readAndStoreValue(CmChannel aChannel)
                              throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### loadFromSub

    protected void loadFromSub(DynamicArray aArray)

#### loadFromSub

    protected void loadFromSub(int aLoadIndex)

#### getBooleanSub

    protected boolean getBooleanSub()
                             throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getByteSub

    protected byte getByteSub()
                       throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getBytesSub

    protected byte[] getBytesSub()
                          throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getShortSub

    protected short getShortSub()
                         throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getIntSub

    protected int getIntSub()
                     throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getLongSub

    protected long getLongSub()
                       throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getFloatSub

    protected float getFloatSub()
                         throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getDoubleSub

    protected double getDoubleSub()
                           throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getBigDecimalSub

    protected java.math.BigDecimal getBigDecimalSub()
                                             throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getStringSub

    protected java.lang.String getStringSub()
                                     throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getAsciiStreamSub

    protected java.io.InputStream getAsciiStreamSub()
                                             throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getBinaryStreamSub

    protected java.io.InputStream getBinaryStreamSub()
                                              throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getCharacterStreamSub

    protected java.io.Reader getCharacterStreamSub()
                                            throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getObjectSub

    protected java.lang.Object getObjectSub()
                                     throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### setValueSub

    protected void setValueSub(java.lang.Object aValue)
                        throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### clearCurrentColumnValue

    public void clearCurrentColumnValue()

#### addMappedJdbcTypeSet

    protected void addMappedJdbcTypeSet(int aType)

#### getMappedJDBCTypes

    public java.util.Set<java.lang.Integer> getMappedJDBCTypes()

Specified by:
  `getMappedJDBCTypes` in interface `Column`

#### getDateSub

    protected final java.sql.Date getDateSub()
                                      throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getDateSub

    protected java.sql.Date getDateSub(java.util.Calendar aCalendar)
                                throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getTimeSub

    protected final java.sql.Time getTimeSub()
                                      throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getTimeSub

    protected java.sql.Time getTimeSub(java.util.Calendar aCalendar)
                                throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getTimestampSub

    protected final java.sql.Timestamp getTimestampSub()
                                                throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getTimestampSub

    protected java.sql.Timestamp getTimestampSub(java.util.Calendar aCalendar)
                                          throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getBlobSub

    protected java.sql.Blob getBlobSub()
                                throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getClobSub

    protected java.sql.Clob getClobSub()
                                throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### setNull

    protected void setNull()

#### setNullOrNotNull

    protected void setNullOrNotNull()

#### isNumberType

    public final boolean isNumberType()

Specified by:
  `isNumberType` in interface `Column`

#### isMappedJDBCType

    public boolean isMappedJDBCType(int aSqlType)

Specified by:
  `isMappedJDBCType` in interface `Column`

#### readParamsFrom

    public void readParamsFrom(CmChannel aChannel)
                        throws java.sql.SQLException

Specified by:
  `readParamsFrom` in interface `Column`
Throws:
  `java.sql.SQLException`

#### readParamsFromSub

    public void readParamsFromSub(CmChannel aChannel)
                           throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### readFrom

    public void readFrom(CmChannel aChannel,
                         CmFetchResult aFetchResult)
                  throws java.sql.SQLException

Description copied from interface: `Column`
채널로부터 컬럼데이터를 읽어와 해당하는 인덱스의 DynamicArray에 바로 저장한다.

Specified by:
  `readFrom` in interface `Column`
Parameters:
  `aChannel` - 소켓통신을 위한 채널객체
  `aFetchResult` - DynamicArray에 대한 인터페이스를 가지고 있는 객체
Throws:
  `java.sql.SQLException` - 소켓통신시 예외가 발생한 경우

#### getMaxBinaryLength

    public int getMaxBinaryLength()

#### setMaxBinaryLength

    public void setMaxBinaryLength(int aMaxLength)

Specified by:
  `setMaxBinaryLength` in interface `Column`

#### loadFrom

    public void loadFrom(DynamicArray aArray)

Specified by:
  `loadFrom` in interface `Column`

#### loadFrom

    public void loadFrom(int aLoadIndex)

Description copied from interface: `Column`
ArrayList로 부터 컬럼데이터를 읽어들인다.

Specified by:
  `loadFrom` in interface `Column`

#### setColumnInfo

    public void setColumnInfo(ColumnInfo aInfo)

Specified by:
  `setColumnInfo` in interface `Column`

#### getColumnInfo

    public ColumnInfo getColumnInfo()

Specified by:
  `getColumnInfo` in interface `Column`

#### isNull

    public boolean isNull()

Specified by:
  `isNull` in interface `Column`

#### setValue

    public void setValue(java.lang.Object aValue)
                  throws java.sql.SQLException

Specified by:
  `setValue` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getBoolean

    public boolean getBoolean()
                       throws java.sql.SQLException

Specified by:
  `getBoolean` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getByte

    public byte getByte()
                 throws java.sql.SQLException

Specified by:
  `getByte` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getBytes

    public byte[] getBytes()
                    throws java.sql.SQLException

Specified by:
  `getBytes` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getShort

    public short getShort()
                   throws java.sql.SQLException

Specified by:
  `getShort` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getInt

    public int getInt()
               throws java.sql.SQLException

Specified by:
  `getInt` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getLong

    public long getLong()
                 throws java.sql.SQLException

Specified by:
  `getLong` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getFloat

    public float getFloat()
                   throws java.sql.SQLException

Specified by:
  `getFloat` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getDouble

    public double getDouble()
                     throws java.sql.SQLException

Specified by:
  `getDouble` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getBigDecimal

    public java.math.BigDecimal getBigDecimal()
                                       throws java.sql.SQLException

Specified by:
  `getBigDecimal` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getString

    public java.lang.String getString()
                               throws java.sql.SQLException

Specified by:
  `getString` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getDate

    public java.sql.Date getDate()
                          throws java.sql.SQLException

Specified by:
  `getDate` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getDate

    public java.sql.Date getDate(java.util.Calendar aCalendar)
                          throws java.sql.SQLException

Specified by:
  `getDate` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getTime

    public java.sql.Time getTime()
                          throws java.sql.SQLException

Specified by:
  `getTime` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getTime

    public java.sql.Time getTime(java.util.Calendar aCalendar)
                          throws java.sql.SQLException

Specified by:
  `getTime` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getTimestamp

    public java.sql.Timestamp getTimestamp()
                                    throws java.sql.SQLException

Specified by:
  `getTimestamp` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getTimestamp

    public java.sql.Timestamp getTimestamp(java.util.Calendar aCalendar)
                                    throws java.sql.SQLException

Specified by:
  `getTimestamp` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getAsciiStream

    public java.io.InputStream getAsciiStream()
                                       throws java.sql.SQLException

Specified by:
  `getAsciiStream` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getBinaryStream

    public java.io.InputStream getBinaryStream()
                                        throws java.sql.SQLException

Specified by:
  `getBinaryStream` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getCharacterStream

    public java.io.Reader getCharacterStream()
                                      throws java.sql.SQLException

Specified by:
  `getCharacterStream` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getBlob

    public java.sql.Blob getBlob()
                          throws java.sql.SQLException

Specified by:
  `getBlob` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getClob

    public java.sql.Clob getClob()
                          throws java.sql.SQLException

Specified by:
  `getClob` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getObject

    public java.lang.Object getObject()
                               throws java.sql.SQLException

Specified by:
  `getObject` in interface `Column`
Throws:
  `java.sql.SQLException`

#### getColumnIndex

    public int getColumnIndex()

Description copied from interface: `Column`
컬럼의 인덱스를 가져온다.

Specified by:
  `getColumnIndex` in interface `Column`
Returns:
  컬럼 인덱스

#### setColumnIndex

    public void setColumnIndex(int aColumnIndex)

Description copied from interface: `Column`
컬럼 인덱스를 셋팅한다.

Specified by:
  `setColumnIndex` in interface `Column`
Parameters:
  `aColumnIndex` - 컬럼 인덱스

#### clearValues

    public void clearValues()

Description copied from interface: `Column`
컬럼데이터가 저장되어 있는 ArrayList를 초기화 한다.

Specified by:
  `clearValues` in interface `Column`

#### setCleared

    public void setCleared(boolean aIsCleared)

Specified by:
  `setCleared` in interface `Column`

#### isCleared

    public boolean isCleared()

Specified by:
  `isCleared` in interface `Column`

#### clearCurrentValue

    public void clearCurrentValue()

Specified by:
  `clearCurrentValue` in interface `Column`